function Dice_Load()
	success_01 = RegisterAddonMessagePrefix("LD_DICING");	
	if (success_01 == true ) then
		print("\124cFFFF0000[Liar's Dice] \124cFFFFFFFFLoaded. \124cFFFFFF00Look at my hat!");
		print("\124cFFFF0000[Liar's Dice] \124cFFFFFFFFType \124cFFFFFF00/dice help\124cFFFFFFFF for instructions.");
	else
		print("\124cFFFF0000[Liar's Dice] \124cFFFFFFFFNot loaded. You have too many addons conflicting.");
	end
	LastDice=" ";

 end
SLASH_LIARSDICE1, SLASH_LIARSDICE2 = '/ld', '/dice';
local function handler(msg, editbox)

local command, arg1, arg2, arg3 = strsplit(" ",msg)

	if tonumber(command) and tonumber(arg1) then
		RollDice(command, arg1);
		local MSG_PREFIX ="LD_DICING";
		local playerName = UnitName("player");
		SendAddonMessage(MSG_PREFIX, "RL\#"..playerName.."\# shuffled their dice.", "RAID");
	elseif tonumber(command) then
		RollDice(command, 6);
		local MSG_PREFIX ="LD_DICING";
		local playerName = UnitName("player");
		SendAddonMessage(MSG_PREFIX,"RL\#"..playerName.."\# shuffled their dice.", "RAID");
	elseif command=="help" then
		print("\124cFFFF0000[Liar's Dice]\124cFFFFFFFF Type \124cFFFFFF00/dice X Y\124cFFFFFFFF or \124cFFFFFF00/ld X Y\124cFFFFFFFF \124cFFFFFF00");
		print("\124cFFFF0000[Liar's Dice]\124cFFFFFFFF X stands for the amount of dice rolled. \124cFFFFFF00");
		print("\124cFFFF0000[Liar's Dice]\124cFFFFFFFF Y stands for the amount of eyes on the dice \124cFFFFFF00(defaults to 6 if left blank). \124cFFFFFF00");
		print("\124cFFFF0000[Liar's Dice]\124cFFFFFFFF Type \124cFFFFFF00/dice last\124cFFFFFFFF \124cFFFFFFFFto print your last roll again in your chatwindow (for yourself).");
		print("\124cFFFF0000[Liar's Dice]\124cFFFFFFFF Type \124cFFFFFF00/dice cheat #####..##\124cFFFFFFFF \124cFFFFFFFFto change your last roll to the new values (!!Cheating!! you can be found out by other players, good luck!)");
		print("\124cFFFF0000[Liar's Dice]\124cFFFFFFFF Type \124cFFFFFF00/dice reveal\124cFFFFFFFF \124cFFFFFFFFto reveal your last dice rolled in an emote for everyone to see.");
	elseif command =="reveal" then
		if GetDice()==" " then
			print("\124cFFFF0000[Liar's Dice]\124cFFFFFFFF You must roll first before you can reveal your dice! Try \124cFFFFFF00/dice help\124cFFFFFFFF.\124cFFFFFF00");
		else
			if (GetNumGroupMembers() > 0) then
				local MSG_PREFIX ="LD_DICING";
				local playerName = UnitName("player");
				SendAddonMessage(MSG_PREFIX,"RV\#"..playerName.."\#"..GetDice(), "RAID");
			else
				SendChatMessage("reveals: " ..GetDice()..".", "EMOTE", DEFAULT_CHAT_FRAME.editBox.languageID);
			end
		end
	elseif command =="last" then
		if GetDice()==" " then
			print("\124cFFFF0000[Liar's Dice]\124cFFFFFFFF You must've rolled first before you can see your previous roll! Try \124cFFFFFF00/dice help\124cFFFFFFFF.\124cFFFFFF00");
		else
			print("\124cFFFF0000[Liar's Dice]\124cFFFFFFFF You rolled: \124cFFFFFF00"..GetDice())
			local MSG_PREFIX ="LD_DICING";
			local playerName = UnitName("player");
			local LOOK_DEX = math.random(100);
			SendAddonMessage(MSG_PREFIX,"LK\#"..playerName.."\#"..LOOK_DEX, "RAID");	
		end
	elseif command =="cheat" then
		if GetDice()==" " then
			print("\124cFFFF0000[Liar's Dice]\124cFFFFFFFF You must've rolled first before you can tinker with your rolls! Try \124cFFFFFF00/dice help\124cFFFFFFFF.\124cFFFFFF00");
		else
			if arg1 ~= nil then
				local DICE_CHEAT = ""
				for i = 1, #arg1 do
					local c = arg1:sub(i,i);
					DICE_CHEAT = DICE_CHEAT.." "..c;
				end
				SaveDice(DICE_CHEAT);
				local CHEAT_DEX = math.random(100);
				print("\124cFFFF0000[Liar's Dice]\124cFFFFFFFF You cheated and changed your dice to: \124cFFFF0000(Sleight of hand: "..CHEAT_DEX..")\124cFFFFFFFF \124cFFFFFF00"..DICE_CHEAT)
				local MSG_PREFIX ="LD_DICING";
				local playerName = UnitName("player");
				SendAddonMessage(MSG_PREFIX,"CT\#"..playerName.."\#"..CHEAT_DEX, "RAID");	
			else
				print("\124cFFFF0000[Liar's Dice]\124cFFFFFFFF You must add a new value to change(cheat) your rolls! Try \124cFFFFFF00/dice help\124cFFFFFFFF.\124cFFFFFF00");
			end
		end
	else
		print("\124cFFFF0000[Liar's Dice]\124cFFFFFFFF Invalid parameters, type \124cFFFFFF00/dice help\124cFFFFFFFF for additional info. \124cFFFFFF00");
	end
end
SlashCmdList["LIARSDICE"] = handler; 

function RollDice(msg, eyes)
	stringRoll = "\124cFFFF0000[Liar's Dice]\124cFFFFFFFF You rolled: \124cFFFFFF00";
	stringDice = "";
	
	for i = 1, msg do
		stringDice = stringDice .. " " .. math.random(eyes);
		i = i + 1;
	end
	SaveDice(stringDice);
	print(stringRoll .. stringDice);	
end

function SaveDice(stringDice)
	LastDice = stringDice;	
end

function GetDice()
	return LastDice;
end

if not ReceiveDiceFrame then
   ReceiveDiceFrame = CreateFrame("Frame")
end

local function OnEvent(self, event, prefix, message, channel, sender)
	if prefix == "LD_DICING" then
		local prefixSplit, playerSplit, msgSplit = strsplit("\#",message);
		if prefixSplit == "RL" then
			local playerName, playerRealm = UnitName("player")
			if type(playerRealm) == "nil" then
				playerRealm = GetRealmName():gsub("%s+", "")
			end
			local checkName = playerName .. "-" .. playerRealm;
			if sender ~= checkName then
				print("\124cFFFF0000[Liar's Dice] \124cFFFFFFFF"..playerSplit.." ".. msgSplit);
			end
		elseif prefixSplit == "RV" then
			local playerName, playerRealm = UnitName("player")
			if type(playerRealm) == "nil" then
				playerRealm = GetRealmName():gsub("%s+", "")
			end
			local checkName = playerName .. "-" .. playerRealm;
			if sender ~= checkName then
				print("\124cFFFF0000[Liar's Dice] \124cFFFFFFFF"..playerSplit.." reveals:\124cFFFFFF00 ".. msgSplit..".");
			else
				print("\124cFFFF0000[Liar's Dice] \124cFFFFFFFF".."You reveal:\124cFFFFFF00 ".. msgSplit..".");
			end
		elseif prefixSplit == "CT" then
			local playerName, playerRealm = UnitName("player")
			if type(playerRealm) == "nil" then
				playerRealm = GetRealmName():gsub("%s+", "")
			end
			local checkName = playerName .. "-" .. playerRealm;
			local CHEAT_DEX = tonumber(msgSplit);
			local CHEAT_DETECT = math.random(75);
			local CHEAT_SUSP = CHEAT_DEX / 2;
			if sender ~= checkName then
				if tonumber(CHEAT_DEX) <= tonumber(CHEAT_DETECT) then
					print("\124cFFFF0000[Liar's Dice] \124cFFFFFFFF That rascal \124cFFFFFF00"..playerSplit.."\124cFFFFFFFF is cheating! You saw it with your own eyes!");
				elseif tonumber(CHEAT_SUSP) <= tonumber(CHEAT_DETECT) then
					print("\124cFFFF0000[Liar's Dice] \124cFFFFFFFF Is \124cFFFFFF00"..playerSplit.."\124cFFFFFFFF looking at the dice or tampering with them? You can't quite tell...");
				end
			end
		elseif prefixSplit == "LK" then
			local playerName, playerRealm = UnitName("player")
			if type(playerRealm) == "nil" then
				playerRealm = GetRealmName():gsub("%s+", "")
			end
			local checkName = playerName .. "-" .. playerRealm;
			local LOOK_DEX = tonumber(msgSplit);
			local LOOK_DETECT = math.random(100);
			if sender ~= checkName then
				if tonumber(LOOK_DEX) <= tonumber(LOOK_DETECT) then
					print("\124cFFFF0000[Liar's Dice] \124cFFFFFFFF Is \124cFFFFFF00"..playerSplit.."\124cFFFFFFFF looking at the dice or tampering with them? You can't quite tell...");
				end
			end
		end
	end
end


local frame = ReceiveDiceFrame;
frame:RegisterEvent("CHAT_MSG_ADDON")
frame:SetScript("OnEvent", OnEvent)
